/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package images;

import exceptions.NotFoundImageException;
import exceptions.NotEnaughImagesException;
import images.data.PicturesData;
import java.io.File;
import java.util.ArrayList;
import java.util.Random;
import javax.swing.ImageIcon;

/**
 *
 * @author gabor
 */
public class GameImageList {

  

    private final ArrayList<ImageIcon> ALLPICTURES;
    
    private final String FOLDER = "Pictures";

    private ImageIcon[] randomPicTombTenPictures;
    private ImageIcon[] randomOrderdPictuesArray;
    private ArrayList<Integer> randomNumberList;
    private String[] fileList;

    public GameImageList() throws NotEnaughImagesException, NotFoundImageException {

        fileList = new File(FOLDER).list();

        ALLPICTURES = new ArrayList();
        if (fileList.length == 0) {
            throw new NotFoundImageException();
        } else {
            checkAndAddImages();
            if(ALLPICTURES.size()<PicturesData.getPICINGAMECOUNT()) throw new NotEnaughImagesException();
        }

        randomPicTombTenPictures = new ImageIcon[PicturesData.getPICINGAMECOUNT()];
        randomOrderdPictuesArray = new ImageIcon[randomPicTombTenPictures.length * 2];
        randomNumberList = new ArrayList<>();//veletlen kepsorrend meghatarozasahoz kell

        ChangePicturesInGame();
        MakeRandomInt();
        MakeRandomImageIcon();
    }
//veletlen kepek kivalasztasa

    private void ChangePicturesInGame() {
        for (int i = 0; i < randomPicTombTenPictures.length; i++) {

            randomPicTombTenPictures[i] = ALLPICTURES.get(new Random().nextInt(ALLPICTURES.size()));

        }
        int check = 1;
        do {
            for (int i = 0; i < check;) {
                if (randomPicTombTenPictures[i].getImage().equals(randomPicTombTenPictures[check].getImage())) {
                    randomPicTombTenPictures[check] = ALLPICTURES.get(new Random().nextInt(ALLPICTURES.size()));
                    i = 0;
                } else {
                    i++;
                }
            }

            check++;
        } while (check < randomPicTombTenPictures.length);

    }

    //a jatekban resztvevo kepek szamainak kisorsolasa
    private void MakeRandomInt() {
        for (ImageIcon RandomOrderdArray1 : randomOrderdPictuesArray) {
            randomNumberList.add(new Random().nextInt(randomOrderdPictuesArray.length));
        }
        int checkedElement = 1;
        do {
            for (int i = 0; i < checkedElement;) {
                if (randomNumberList.get(checkedElement).intValue() == randomNumberList.get(i).intValue()) {
                    randomNumberList.set(checkedElement, new Random().nextInt(randomOrderdPictuesArray.length));
                    i = 0;
                } else {
                    i++;
                }
            }
            checkedElement++;
        } while (checkedElement < randomNumberList.size());

        for (int i = 0; i < randomNumberList.size(); i++) {
            if (randomNumberList.get(i) >= randomPicTombTenPictures.length) {
                randomNumberList.set(i, randomNumberList.get(i) - randomPicTombTenPictures.length);

            }
        }
    }
//kepek a kisorsolt veletlen szamokkal valo rendezese

    private void MakeRandomImageIcon() {

        for (int i = 0; i < randomOrderdPictuesArray.length; i++) {
            randomOrderdPictuesArray[i] = new ImageIcon();
            randomOrderdPictuesArray[i] = randomPicTombTenPictures[randomNumberList.get(i)];
        }
    }

    private void checkAndAddImages()  {

        for (String fileName : fileList) {
            ImageIcon tmp = new ImageIcon(FOLDER + "/" + fileName);
            if (tmp.getIconHeight() == PicturesData.getIMAGEHEIGHT() && tmp.getIconWidth() == PicturesData.getIMAGEWIDTH()
                    && (fileName.endsWith(".jpg")
                    || fileName.endsWith(".gif")
                    || fileName.endsWith(".png"))) {
                ALLPICTURES.add(tmp);
            }
        }
     
    }
//getterek

  

    public ImageIcon[] getRandomOrderdPictuesArray() {
        return randomOrderdPictuesArray;
    }

    public int getRandomOrderedPicturesArrayLength() {
        return randomOrderdPictuesArray.length;
    }
}
