/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package view;

import exceptions.NotFoundImageException;
import exceptions.NotEnaughImagesException;
import java.awt.Color;
import java.awt.Component;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.Timer;
import images.BackSideImage;
import images.GameImageList;
import exceptions.NotBacksideImageException;
import images.data.PicturesData;
import mySoundPlay.SimpleWavplay;
import view.labels.ChangeBSJLabel;
import view.labels.StepJlabel;

/**
 *
 * @author gabor
 */
public class KetfarkuFrame extends JFrame implements MouseListener {
//PANEL ELEMEI

    Component[] panelcomponents;
    JPanel panel;

    JLabel[] backPicture;
    JLabel[] kkPicture;

    Timer itt, gst;
 final String SOUNDPATH="sound/kotkodacs.wav";
    int iconCounter;
    final String backPickName = "BackPicture";
    final String kkPicName = "KKkep";
    private static KetfarkuFrame instance = null;

    private final JButton NWGAMEBUTTON;
    GameImageList imageList;
    int step;
    JLabel stepJLabel;
    private JLabel changeBSJLabel;
    JComboBox<String> backSideComboBox;

    public static KetfarkuFrame getInstance() {
        if (instance == null) {
            instance = new KetfarkuFrame();
        }
        return instance;
    }

    private KetfarkuFrame() {

        super("Kétfarku memoria");
        setLayout(null);
        this.setIconImage(new ImageIcon("Logo.jpg").getImage());
        this.setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        step = 0;
        try {
            imageList = new GameImageList();
        } catch (NotEnaughImagesException | NotFoundImageException ex) {
            JOptionPane.showMessageDialog(null, ex);
            System.exit(0);
        }

        iconCounter = 0;
        itt = new ImageTurnTimer(this);
        gst = new GameStartTimer(this);
        itt.setRepeats(false);
        gst.setRepeats(false);

        stepJLabel = new StepJlabel(step);
        NWGAMEBUTTON = new NewGameButton(this);
        backSideComboBox = new BsideChangeJcombo(this);
        changeBSJLabel = new ChangeBSJLabel();

        panel = new JPanel();
        panel.setLayout(null);
      //  panel.setPreferredSize(new java.awt.Dimension(1300, 650));
        panel.setBackground(Color.LIGHT_GRAY);
        panel.setBounds(0, 10, 1366, 570);
//        dataPanel = new JPanel(new FlowLayout());
//        dataPanel.setPreferredSize(new Dimension(270, 400));
        add(stepJLabel);
        add(changeBSJLabel);
        add(backSideComboBox);
        //dataPanel.
        this.add(panel);
        add(NWGAMEBUTTON);

        // this.add(dataPanel);
        backPicture = new JLabel[imageList.getRandomOrderedPicturesArrayLength()];
        kkPicture = new JLabel[imageList.getRandomOrderedPicturesArrayLength()];
        PictureSet();
        addkkPictures();
        setImageBound();

        pack();
        this.setExtendedState(getExtendedState() | JFrame.MAXIMIZED_BOTH);
        this.setVisible(true);
        gst.start();

    }

    private void setImageBound() {
        int startx=140;
        
        int x0 = startx;

        int y0 = 15;

        for (int i = 0; i < backPicture.length; i++) {
            if (i < backPicture.length / 3) {

                backPicture[i].setBounds(x0, y0, PicturesData.getIMAGEWIDTH(), PicturesData.getIMAGEHEIGHT());
                kkPicture[i].setBounds(x0, y0, PicturesData.getIMAGEWIDTH(), PicturesData.getIMAGEHEIGHT());

                x0 += (PicturesData.getIMAGEWIDTH() + 5);
                if (i == backPicture.length / 3 - 1) {
                    x0 = startx;
                    y0 += (PicturesData.getIMAGEHEIGHT() + 5);
                }
            }

            if (i >= backPicture.length / 3 && i < (backPicture.length / 3) * 2) {
                backPicture[i].setBounds(x0, y0, PicturesData.getIMAGEWIDTH(), PicturesData.getIMAGEHEIGHT());
                kkPicture[i].setBounds(x0, y0, PicturesData.getIMAGEWIDTH(), PicturesData.getIMAGEHEIGHT());
                x0 += (PicturesData.getIMAGEWIDTH() + 5);
                if (i == ((backPicture.length / 3) * 2) - 1) {
                    x0 = startx;
                    y0 += (PicturesData.getIMAGEHEIGHT() + 5);
                }
            }
            if (i >= (backPicture.length / 3 * 2)) {
                backPicture[i].setBounds(x0, y0, PicturesData.getIMAGEWIDTH(), PicturesData.getIMAGEHEIGHT());

                kkPicture[i].setBounds(x0, y0, PicturesData.getIMAGEWIDTH(), PicturesData.getIMAGEHEIGHT());
                x0 += (PicturesData.getIMAGEWIDTH() + 5);


            }
        }

    }

    private void PictureSet() {

        for (int i = 0; i < backPicture.length; i++) {
            backPicture[i] = new JLabel();

            backPicture[i].setName(backPickName);
            kkPicture[i] = new JLabel();

            try {
                backPicture[i].setIcon(BackSideImage.getBackSideImage(0));
            } catch (NotBacksideImageException ex) {
                JOptionPane.showMessageDialog(null, ex);
                System.exit(0);
            }

            backPicture[i].addMouseListener(this);
        }
    }

    final void addkkPictures() {

        for (int i = 0; i < kkPicture.length; i++) {
            kkPicture[i].setName(kkPicName);
            kkPicture[i].setIcon(imageList.getRandomOrderdPictuesArray()[i]);
            panel.add(kkPicture[i]);
        }

    }

    @Override
    public void mouseClicked(MouseEvent Me) {

        if (iconCounter < 2) {
            imageChange(Me);

            panel.invalidate();
            panel.repaint();

            panelcomponents = panel.getComponents();

            if (imageCount(panelcomponents) == 2) {
                step++;
                stepJLabel.setText("Lépésszám:  " + step);
                for (int i = 0; i < panelcomponents.length; i++) {
                    if (panelcomponents[i].getName().equals(kkPicName)) {

                        for (int j = i + 1; j < panelcomponents.length; j++) {
                            if (panelcomponents[j].getName().equals(kkPicName)) {

                                JLabel t1 = null;
                                JLabel t2 = null;
                                if (panelcomponents[i] instanceof JLabel && panelcomponents[j] instanceof JLabel) {
                                    t1 = (JLabel) panelcomponents[i];
                                    t2 = (JLabel) panelcomponents[j];
                                }

                                if (t1.getIcon().equals(t2.getIcon())) {

                                    panelcomponents[i].setName("ok");
                                    panelcomponents[j].setName("ok");
                                    okCount(panelcomponents);
                                    iconCounter = 0;
                                    break;
                                } else {
                                    itt.start();
                                }

                            }

                        }
                    }

                }

            }

        }
    }

    @Override
    public void mousePressed(MouseEvent e) {
    }

    @Override
    public void mouseReleased(MouseEvent e) {
    }

    @Override
    public void mouseEntered(MouseEvent e) {
        for (JLabel hkep : backPicture) {

            if (e.getSource().equals(hkep)) {
                setCursor(HAND_CURSOR);
            }

        }
    }

    @Override
    public void mouseExited(MouseEvent e) {
        for (JLabel hkep : backPicture) {

            if (e.getSource().equals(hkep)) {
                setCursor(DEFAULT_CURSOR);
            }

        }
    }

    private void okCount(Component[] panelcomponents) {

        int ok = 0;
        for (Component c : panelcomponents) {
            if (c.getName().equals("ok")) {
                ok++;
            }
           
            if (ok == kkPicture.length) {
                panel.setBackground(Color.green);
                SimpleWavplay.MakeSound(SOUNDPATH);
            }
        }

    }

    private void imageChange(MouseEvent Me) {
        for (int i = 0; i < backPicture.length; i++) {

            if (Me.getSource().equals(backPicture[i])) {

                panel.remove(backPicture[i]);
                panel.add(kkPicture[i]);
            }
        }
    }

    private int imageCount(Component[] panelcomponents) {

        iconCounter = 0;
        for (Component c : panelcomponents) {

            if (c.getName().equals(kkPicName)) {
                //   System.out.println(c.getName());
                iconCounter++;
            }

        }
        return iconCounter;
    }

 

}
